/**
 * ******************************************************************************
 *  Copyright Fujitsu.
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  You may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 * *****************************************************************************
 *
 *  NIFCLOUD SDK for Java
 *
 */
package com.nifty.cloud.sdk.nic.model.transform;

import com.nifty.cloud.sdk.nic.model.Association;
import com.thoughtworks.xstream.converters.Converter;
import com.thoughtworks.xstream.converters.MarshallingContext;
import com.thoughtworks.xstream.converters.UnmarshallingContext;
import com.thoughtworks.xstream.io.HierarchicalStreamReader;
import com.thoughtworks.xstream.io.HierarchicalStreamWriter;

/**
 * Association変換クラス。<br />
 * このクラスはレスポンスXMLのassociation要素からAssociationクラスを生成します。
 *
 */
public class AssociationConverter implements Converter {

    private static final String ELEMENT_ALLOCATION_ID = "allocationId";
    private static final String ELEMENT_ASSOCIATION_ID = "associationId";
    private static final String ELEMENT_IP_OWNER_ID = "ipOwnerId";
    private static final String ELEMENT_PUBLIC_DNS_NAME = "publicDnsName";
    private static final String ELEMENT_PUBLIC_IP = "publicIp";

    /**
     * 変換可能なクラスか判定します。
     *
     * @param clazz
     *            クラス
     * @return 変換可能な場合true, 変換不可能な場合false
     *
     * @see com.thoughtworks.xstream.converters.Converter#canConvert(Class)
     */
    @SuppressWarnings("rawtypes")
    @Override
    public boolean canConvert(Class clazz) {
        return clazz == Association.class;
    }

    /**
     * {@literal
     * AssociationをAssociationクラスに変換します。}
     *
     * @param reader
     *            XML読込リーダ
     * @param context
     * @return {@literal Associationオブジェクト}
     *
     * @see com.thoughtworks.xstream.converters.Converter#unmarshal(HierarchicalStreamReader,
     *      UnmarshallingContext)
     */
    @Override
    public Object unmarshal(HierarchicalStreamReader reader, UnmarshallingContext context) {
        Association association = new Association();

        String name = null;
        while (reader.hasMoreChildren()) {
            reader.moveDown();

            name = reader.getNodeName();
            if (name.equals(ELEMENT_ALLOCATION_ID)) {
                association.setAllocationId(reader.getValue());
            } else if (name.equals(ELEMENT_ASSOCIATION_ID)) {
                association.setAssociationId(reader.getValue());
            } else if (name.equals(ELEMENT_IP_OWNER_ID)) {
                association.setIpOwnerId(reader.getValue());
            } else if (name.equals(ELEMENT_PUBLIC_DNS_NAME)) {
                association.setPublicDnsName(reader.getValue());
            } else if (name.equals(ELEMENT_PUBLIC_IP)) {
                association.setPublicIp(reader.getValue());
            }

            reader.moveUp();
        }

        return association;
    }

    /**
     * 未実装メソッド
     */
    @Override
    public void marshal(Object paramObject,
        HierarchicalStreamWriter paramHierarchicalStreamWriter,
        MarshallingContext paramMarshallingContext) {
        // 処理無し
    }
}
